setInfos(4, "Sissy Training", "", "e43000, doti", "started", 0xFFFFFF, "en", ["femaledom", "formale", "long", "transgender"]);

//TODO 
// - find a better name
// - add some texts (intro, etc., see ??)
// - add pictures
// - add scripts (here and files in sissytraining subfolder)
// - add assignments here
// - add some metadata (summary, tags, bg color)

// scripts : array of map
// - needs : list of script filenames, dependencies
// - script (unique) : script name, file is sissytraining/[name].groovy
def scripts = [
	["needs":[], "name":"Clothing Training - level 1", "script":"clothingtraining1"],
	["needs":["clothingtraining1"], "name":"Clothing Training - level 2", "script":"clothingtraining2"],
]

// assignments : array of map
// - needs : list of script filenames, dependencies
// - week : week of appearance / that is, first week
// - points : positive gain
// - name, desc : infos
def assignments = [
	["needs":[], "week":1, "points":50, "name":"Shave legs", "desc":"Shave your legs" ], 
	["needs":[], "week":2, "points":50, "name":"Pedicure", "desc":"Give yourself a pedicure" ], 
	["needs":["clothingtraining1"], "week":1, "points":50, "name":"Wear thong", "desc":"Wear a thong during 4 hours" ],
]

// 1 week
def PERIOD = 3600*24*7
// do not receive an assignment or a script just before the end of the week
def DELAY_BEFORE_PERIOD_END = 3600*24
def STARTING_POINTS = 800
def PENALTY_MISSED_SCRIPT = 100

// possible intro
if(loadInteger("sissytraining.introed")==null) {
	show("??intro??\n(as this script is still a simple stub, some texts are missing)");
	showButton("ok")
	show("??intro2??");
	showButton("ok")
	//and so and so : explain everything
	save("sissytraining.introed", getTime())
	save("sissytraining.points", STARTING_POINTS)
} else {
	//short intro, seen each time 
	show("??hello??");
	wait(2);
}

// 1, 2...
def currentWeek = 1+(int)((getTime() - loadInteger("sissytraining.introed")) / PERIOD)
// compare this to getTime()
def weekStart = loadInteger("sissytraining.introed")+PERIOD * (currentWeek-1)


// if some assigned tasks not done
def notDoneText = ""
def sep = ""
//"if(true)" : to create block, separating variables ("def i" each time)
if(true){
	def i = 0
	for(def script : scripts) {
		def startTime = loadInteger("sissytraining.script"+i+".starttime")
		def endTime = loadInteger("sissytraining.script"+i+".endtime")
		if(startTime!=null && startTime<getTime()-PERIOD && endTime==null) {
			notDoneText += sep + script["name"]
			sep = ", "
			save("sissytraining.points", loadInteger("sissytraining.points")-
				PENALTY_MISSED_SCRIPT)
			save("sissytraining.script"+i+".starttime", null)
		}
		i++
	}
}
if(true){
	def i = 0
	for(def assignment : assignments) {
		def startTime = loadInteger("sissytraining.assignment"+i+".starttime")
		def endTime = loadInteger("sissytraining.assignment"+i+".endtime")
		if(startTime!=null && startTime<getTime()-PERIOD && endTime==null) {
			notDoneText += sep + assignment["name"]
			sep = ", "
			save("sissytraining.points", loadInteger("sissytraining.points")-assignment["points"])
			save("sissytraining.assignment"+i+".starttime", null)
		}
		i++
	}
}
if(notDoneText!="") {
	show("You did not complete : "+notDoneText+" !")
	showButton("Well...")
}


// new tasks
if(getTime()<weekStart+PERIOD-DELAY_BEFORE_PERIOD_END){
	def i = 0
	for(def script : scripts) {	
		def startTime = loadInteger("sissytraining.script"+i+".starttime")
		if(startTime==null) {
			def doneEverything = true;
			for(def need:script["needs"]) {
				def j = 0
				for(def script2 : scripts) {
					if(script2["script"]==need && 
							loadInteger("sissytraining.script"+j+".endtime")==null)
						doneEverything = false;
					j++
				}
			}
			if(doneEverything) {
				save("sissytraining.script"+i+".starttime", weekStart)
			}
		}
		i++
	}
}
if(getTime()<weekStart+PERIOD-DELAY_BEFORE_PERIOD_END){
	def i = 0
	for(def assignment : assignments) {
		def startTime = loadInteger("sissytraining.assignment"+i+".starttime")
		def endTime = loadInteger("sissytraining.assignment"+i+".endtime")
		def endTimeWeek = null
		if(endTime!=null)
			endTimeWeek = 1+(int) ((endTime - loadInteger("sissytraining.introed")) / PERIOD)
		if((startTime==null || (endTimeWeek!=null && endTimeWeek!=currentWeek)) && 
				currentWeek >= assignment["week"]) {
			def doneEverything = true;
			for(def need:assignment["needs"]) {
				def j = 0
				for(def script2 : scripts) {
					if(script2["script"]==need && 
							loadInteger("sissytraining.script"+j+".endtime")==null)
						doneEverything = false;
					j++
				}
			}
			if(doneEverything) {
				save("sissytraining.assignment"+i+".starttime", weekStart)
				save("sissytraining.assignment"+i+".endtime", null)
			}
		}
		i++
	}
}


// main infos (time, what to do)
def stayingTime = loadInteger("sissytraining.introed") - getTime() - 5
while(stayingTime<=0)
	stayingTime+=PERIOD
def stayingTimeText = ((int) (1 + stayingTime / 60))+" minutes"
if(stayingTime>3600 * 1.5)
	stayingTimeText = ((int) (1 + stayingTime / 3600 ))+" hours"
if(stayingTime>3600 * 30)
	stayingTimeText = ((int) (1 + stayingTime / 3600 / 24 ))+" days"

def currentScriptsList = []
def currentAssignmentsList = []
def currentListText = ""
if(true){
	def i = 0
	for(def script : scripts) {
		def startTime = loadInteger("sissytraining.script"+i+".starttime")
		def endTime = loadInteger("sissytraining.script"+i+".endtime")
		if(startTime!=null && endTime==null) {
			currentScriptsList += script
			//for how many points ? in script, depending on it, can't show here
			currentListText += "\n- Train : "+script["name"]
		}
		i++
	}
}
if(true){
	def i = 0
	for(def assignment : assignments) {
		def startTime = loadInteger("sissytraining.assignment"+i+".starttime")
		def endTime = loadInteger("sissytraining.assignment"+i+".endtime")
		if(startTime!=null && endTime==null) {
			currentAssignmentsList += assignment
			currentListText += "\n- "+assignment["desc"]+" for "+assignment["points"]+" points"
		}
		i++
	}
}
if(currentListText=="")
	currentListText = "\n\nNothing more to complete this week, you'll just have to wait !"
show("You have "+loadInteger("sissytraining.points")+" points now."+
	"\n\nHere are your current assignments, you have now less than "+stayingTimeText+
	" to complete them :"+currentListText);

def menu = getSelectedValue(null,
	["report", "train", "spend 1000 points for an orgasm", "leave"]
)
switch(menu) {
case 0:
	def list = ["None, I did a mistake"]
	for(def assignment:currentAssignmentsList) 
		list += assignment["name"]
	def value = getSelectedValue("Select an assignment you just done", list)
	if(value>0) {
		def i = 0
		for(def assignment : assignments) {
			if(assignment["name"] == currentAssignmentsList[value-1]["name"]) {
				save("sissytraining.assignment"+i+".endtime", getTime())
				save("sissytraining.points", loadInteger("sissytraining.points")+
					assignment["points"])
				show("You have "+loadInteger("sissytraining.points")+" now.")
				wait(3)
			}
			i++
		}
	} else {
		show("")
	}
	break;
case 1:
	def list = ["Nothing, it was a mistake"]
	for(def script:currentScriptsList) 
		list += script["name"]
	def value = getSelectedValue("Select a training you want to do now", list)
	if(value>0) {
		return "sissytraining/"+currentScriptsList[value-1]["script"]
	} else {
		show("")
	}
	break;
case 2:
	if(loadInteger("sissytraining.points")>=1000) {
		show("??orgasmok??")
		save("sissytraining.points", loadInteger("sissytraining.points")-1000)
	} else {
		show("??orgasmnotok??")
	}
	break;
default:
	show("")
}

wait(2)

// This script, from http://ss.deviatenow.com, is protected by this licence : 
// CC by-NC, see http://creativecommons.org/licenses/by-nc/3.0/

/*
 * Resources
 * scripts/sissytraining.groovy
 * scripts/sissytraining/clothingtraining1.groovy
 * scripts/sissytraining/clothingtraining2.groovy
 */